#include "engineinstance.hpp"


#include "intropart.hpp"
#include "titlepart.hpp"
#include "mainpart.hpp"
#include "cutscene.hpp"

GameEngine::GameEngine()
{
    global_variables = new Global_Variables();

    soundengine->loadsound("audio/jumpa.wav");
    soundengine->loadsound("audio/jumpb.wav");
    soundengine->loadsound("audio/land.wav");
    soundengine->loadsound("audio/collect2.wav");
    soundengine->loadsound("audio/diea.wav");
    soundengine->loadsound("audio/startlevel.wav");
    soundengine->loadsound("audio/finish.wav");
    soundengine->streamtrack("audio/level6.mp3");


    section.push_back(new IntroPart ( this , global_variables ) );
    section.push_back(new TitlePart ( this , global_variables ) );
    section.push_back(new CutScene  ( this , global_variables ) );
    section.push_back(new MainPart  ( this , global_variables ) );

}

GameEngine::~GameEngine()
{
}


int GameEngine::control(int oldpart, int message)
{
    if (message<0)
        return -1;

    switch (oldpart)
    {
    case 0://intro
        return 1;
        break;
    case 1://title
        return 2;
        break;
    case 2://cutscene 1
        switch (message)
        {
        case 1:
            return 3;
            break;
        case 2:
            return 1;
            break;
        }
        break;
    case 3://main game
        switch (message)
        {
        case 1://win
            global_variables->level++;
            return 2;
            break;
        case 3://go to title secreen;
            return 1;
            break;
        default:
            return -1;
            break;
        }
        break;
    }
    return -1;
}
