#include "entities.hpp"
#include "gamestrings.hpp"
#include "mathstuff.hpp"

enum SoundEffects {se_jump1=0,se_jump2=1,se_land=2,se_collect=3,se_die=4};

void Player::move()
{

    if (playerstate==ps_ledgegrab)
    {

        {
            if (statecounter%ledgespeed==0)
            {
                switch (statecounter/ledgespeed)
                {
                    case 0:

                    break;
                    case 1:
                        y+=2;
                    break;
                    case 2:
                        y+=2;
                        if (facingl)
                            x-=2;
                        else
                            x+=2;
                    break;
                    case 3:
                        playerstate=ps_standing;
                        statecounter=0;
                    break;
                    default:
                    break;

                }
            }
        }

        if ((facingl&&!dirs[2])||((!facingl)&&!dirs[3]))
        {
            if (statecounter/ledgespeed < 2)
            {
                if (facingl)
                    x++;
                else
                    x--;
            }
            playerstate=ps_standing;
        }

        tile=2*tilesperline*num+tilesperline*facingl+12+statecounter/ledgespeed;

        statecounter++;
        if (playerstate==ps_ledgegrab)
        {
            return;//the logic is easier if I just short circuit everything else
        }
    }

    if (playerstate==ps_walking)
    {
        playerstate=ps_standing;
    }
    else if (playerstate==ps_landing)
    {
        statecounter--;
        if (statecounter<=0)
            playerstate=ps_standing;
    }

    if (playerstate==ps_jumping)
    {
        if (!(map->mask[(y+4)/7][x/7]) || (!map->mask[(y+4)/7][(x+3)/7]))
        {
            //if upward path partially obstructed, then move player
            if (map->mask[(y+4)/7][x/7])//RIGHT BLOCK FEE
            {
                x=((x+3)/7)*7;
            }
            else if (map->mask[(y+4)/7][(x+3)/7])//LEFT BLOCK FREE
            {
                x=((x+3)/7)*7-4;
            }

            if (statecounter>5)
                y+=3;
            else
                y+=2;
        }
        else
        {
            if (!(map->mask[(y+2)/7][x/7] || map->mask[(y+2)/7][(x+3)/7]))
            {
                y+=2;
            }
            else if (!(map->mask[(y+1)/7][x/7] || map->mask[(y+1)/7][(x+3)/7]))
            {
                y+=1;
            }
            playerstate=ps_falling;
        }

        statecounter--;
        if (statecounter<=0)
        {
            playerstate=ps_falling;
        }

    } else if (playerstate!=ps_dying)
    {


        {

            //do gravity stuff
            if (!(map->mask[(y-8)/7][x/7] || map->mask[(y-8)/7][(x+3)/7]))
            {
                y-=2;
                if (!onplatform)
                    playerstate=ps_falling;
            }
            else if (!(map->mask[(y-7)/7][x/7] || map->mask[(y-7)/7][(x+3)/7]))
            {
                y-=1;
                if (!onplatform)
                {
                    playerstate=ps_landing;
                    statecounter=12;
                }
            }
            else if (playerstate==ps_falling)
            {
                if (!onplatform)
                {
                    playerstate=ps_landing;
                    statecounter=12;
                }
            }
        }

        //if on terra firma
        if (playerstate!=ps_falling || onplatform)
        {
             if (dirs[0])
            {
                playerstate=ps_crouching;
            }
        }
    }

    if (playerstate==ps_crouching)
    {
            if (dirs[2])
                facingl=true;
            else if (dirs[3])
                facingl=false;

            if (!dirs[0])
            {
                float dx=(map->player[0]->x-map->player[1]->x);
                float dy=(map->player[0]->y-map->player[1]->y);
                float d=sqrt(dx*dx+dy*dy);
                statecounter=(int) (7.0f+ min(max(-d/60.0f+1.0f,0.0f),1.0f)*7);
                playerstate=ps_jumping;
                if (num)
                    soundengine->play(se_jump2);
                else
                    soundengine->play(se_jump1);
            }
    }

    /*
    if (dirs[1])
    {
        if (!(map->mask[(y-1)/7][x/7] || map->mask[(y-1)/7][(x+3)/7]))
            y--;
    }*/
    if (playerstate!=ps_crouching && playerstate!=ps_dying)
        {
        if (dirs[2])
        {
            facingl=true;
            if (!(map->mask[y/7][(x-1)/7]))
            {
                if (!map->mask[(y-6)/7][(x-1)/7])
                {
                    x--;
                    if (playerstate==ps_standing||playerstate==ps_landing|| (playerstate==ps_ledgegrab&&(statecounter/ledgespeed==2)))
                    {
                        playerstate=ps_walking;
                        frame=(frame+1)%12;
                    }
                }
                else//ledgegrab
                {
                    y=(((y-6)/7)+1)*7+2;
                    x--;
                    //don't need to changex=((x+3+1)/7)*7;
                    playerstate=ps_ledgegrab;
                    statecounter=0;
                }

            }
        }
        if (dirs[3])
        {
            facingl=false;
            if (!(map->mask[y/7][(x+3+1)/7]))
            {
                if (!map->mask[(y-6)/7][(x+3+1)/7])
                {
                    x++;
                    if (playerstate==ps_standing||playerstate==ps_landing)
                    {
                        playerstate=ps_walking;
                        frame=(frame+1)%12;
                    }
                }
                else //LEDGE
                {
                    y=(((y-6)/7)+1)*7+2;
                    x++;
                    //don't need to changex=((x+3+1)/7)*7;
                    playerstate=ps_ledgegrab;
                    statecounter=0;
                }
            }
        }
    }

    if (playerstate==ps_standing)
        frame=2;

    if (playerstate==ps_dying)
    {
        statecounter--;
        if (statecounter<=0)
        {
            respawn();
        }
    }

    switch (playerstate)
    {
        case ps_standing:
            tile=2*tilesperline*num+tilesperline*facingl+2;
            break;
        case ps_dying:
            tile=(((statecounter/5)%2)==0?2*tilesperline*num+tilesperline*facingl+11:-1);
            break;
        case ps_walking:
            tile=2*tilesperline*num+tilesperline*facingl+frame/2;
            break;
        case ps_crouching:
            tile=2*tilesperline*num+tilesperline*facingl+8;
            break;
        case ps_jumping:
            tile=2*tilesperline*num+tilesperline*facingl+9;
            break;
        case ps_falling:
            tile=2*tilesperline*num+tilesperline*facingl+10;
            break;
        case ps_landing:
            tile=2*tilesperline*num+tilesperline*facingl+11;
            break;
        case ps_ledgegrab:
            //SHOULD NEVER GET HERE
            break;
    }
}

void Player::respawn()
{
    playerstate=ps_standing;
    statecounter=0;
    x=startx;
    y=starty;
}


void Player::kill()
{
    if (playerstate!=ps_dying)
    {
        playerstate=ps_dying;
        soundengine->play(se_die);
        statecounter=30;
    }
}

static inline bool onplatform(int px,int py,int platx,int platy)
{
    return ((py-6==platy) && (px+3>=platx) && (px<=platx+5));
}

void Platform::carry(int i)
{
        //check who, if anyone, it's carrying
    if (ticker==0)
    {
        carrying[i]=onplatform(map->player[i]->x,map->player[i]->y,x,y);

        if (!turning)
        {
            switch (d)
            {
                case d_up:
                    //
                break;
                case d_down:
                    //
                break;
                case d_left:
                        if (carrying[i])
                            map->player[i]->x--;
                break;
                case d_right:
                        if (carrying[i])
                            map->player[i]->x++;
                break;
            }
        }
    }

}

void Platform::move()
{

    ticker=(ticker+1)%3;
    if (ticker==0)
    {
        switch (d)
        {
            case d_up:
                //tryMove (d_up);
            break;
            case d_down:
                //tryMove (d_down);
            break;
            case d_left:
                if (!(map->mask[y/7-1][(x-8)/7]))
                {
                    x--;
                    turning=false;
                }
                else
                {
                    d=d_right;
                    turning=true;
                }
            break;
            case d_right:
                if (!(map->mask[y/7-1][(x+14)/7]))
                {
                    x++;
                    turning=false;
                }
                else
                {
                    d=d_left;
                    turning=true;

                }
                break;
        }
    }
}

Spikes::Spikes(int ex, int ey,Map* emap, int tiledir,SoundEngine* esoundengine):
MEntity(ex,ey,7,7,e_spike,-1,emap,esoundengine)
{
    switch (tiledir)
    {
     case 6:
        x++;
        width-=2;
        y-=3;
        height-=3;
        break;
     case 7:
        x++;
        width-=2;
        height-=3;
        break;
     case 12:
        width-=3;
        y++;
        height-=2;
        break;
     case 13:
        x+=3;
        width-=3;
        y++;
        height-=2;
        break;
    }

}


Heart::Heart(int ex, int ey,Map* emap,SoundEngine* esoundengine):
MEntity(ex,ey,7,7,e_spike,-1,emap,esoundengine),
collected(0)
{
tile=10;
}
